(in-package :test-roslisp)

(rem-all-tests)

(deftest negate
    (list
     (roslisp-extended-reals::negate 3)
     (roslisp-extended-reals::negate -3)
     (roslisp-extended-reals::negate 0)
     (roslisp-extended-reals::negate 'roslisp-extended-reals:infty)
     (roslisp-extended-reals::negate 'roslisp-extended-reals:-infty))
  (-3 3 0 roslisp-extended-reals:-infty roslisp-extended-reals:infty))

(deftest subtract
    (list
     (roslisp-extended-reals::subtract 7 3)
     (roslisp-extended-reals::subtract 3 7)
     ;; infty
     (roslisp-extended-reals::subtract 'roslisp-extended-reals:infty 'roslisp-extended-reals:-infty)
     (roslisp-extended-reals::subtract 'roslisp-extended-reals:-infty 'roslisp-extended-reals:infty)
     ;; infty number
     (roslisp-extended-reals::subtract 'roslisp-extended-reals:infty 7)
     (roslisp-extended-reals::subtract 'roslisp-extended-reals:-infty 7)
     (roslisp-extended-reals::subtract 7 'roslisp-extended-reals:infty)
     (roslisp-extended-reals::subtract 7 'roslisp-extended-reals:-infty))
  (4
   -4
   ;; infty
   roslisp-extended-reals:infty
   roslisp-extended-reals:-infty
   ;; infty number
   roslisp-extended-reals:infty
   roslisp-extended-reals:-infty
   roslisp-extended-reals:-infty
   roslisp-extended-reals:infty))

;; pending roslisp bugfix release
;; (deftest add-ext
;;     (list
;;      (roslisp-extended-reals::add-ext 7 3)
;;      ;; infty
;;      (roslisp-extended-reals::add-ext 'roslisp-extended-reals:infty 'roslisp-extended-reals:infty)
;;      (roslisp-extended-reals::add-ext 'roslisp-extended-reals:-infty 'roslisp-extended-reals:-infty)
;;      ;; infty number
;;      (roslisp-extended-reals::add-ext 'roslisp-extended-reals:infty 7)
;;      (roslisp-extended-reals::add-ext 'roslisp-extended-reals:-infty 7)
;;      (roslisp-extended-reals::add-ext 7 'roslisp-extended-reals:infty)
;;      (roslisp-extended-reals::add-ext 7 'roslisp-extended-reals:-infty))
;;   (10
;;    ;; infty
;;    roslisp-extended-reals:infty
;;    roslisp-extended-reals:-infty
;;    ;; infty number
;;    roslisp-extended-reals:infty
;;    roslisp-extended-reals:-infty
;;    roslisp-extended-reals:infty
;;    roslisp-extended-reals:-infty))

(deftest ext>
    (list
     (roslisp-extended-reals::ext> 'roslisp-extended-reals:infty 'roslisp-extended-reals:-infty)
     (roslisp-extended-reals::ext> 'roslisp-extended-reals:infty 0)
     (roslisp-extended-reals::ext> 'roslisp-extended-reals:infty 'roslisp-extended-reals:infty)
     ;; -infty
     (roslisp-extended-reals::ext> 'roslisp-extended-reals:-infty 'roslisp-extended-reals:-infty)
     (roslisp-extended-reals::ext> 'roslisp-extended-reals:-infty 0)
     (roslisp-extended-reals::ext> 'roslisp-extended-reals:-infty 'roslisp-extended-reals:infty)
     ;; num
     (roslisp-extended-reals::ext> 0 'roslisp-extended-reals:-infty)
     (roslisp-extended-reals::ext> 0 -1)
     (roslisp-extended-reals::ext> 0 0)
     (roslisp-extended-reals::ext> 0 1)
     (roslisp-extended-reals::ext> 0 'roslisp-extended-reals:infty)
     )
  (t
   t
   nil
   ;; -infty
   nil
   nil
   nil
   ;;num
   t
   t
   nil
   nil
   nil))

(deftest extmax
    (list
     (roslisp-extended-reals:extmax nil)
     (roslisp-extended-reals:extmax 0)
     (roslisp-extended-reals:extmax 'roslisp-extended-reals:infty)
     (roslisp-extended-reals:extmax 'roslisp-extended-reals:-infty)
     (roslisp-extended-reals:extmax 'roslisp-extended-reals:infty 'roslisp-extended-reals:-infty 0)
     (roslisp-extended-reals:extmax 'roslisp-extended-reals:-infty 0))
  (nil
   0
   roslisp-extended-reals:infty roslisp-extended-reals:-infty
   roslisp-extended-reals:infty
   0))

(deftest ext+
    (list
     (roslisp-extended-reals:ext+ 3)
     (roslisp-extended-reals:ext+ 1 2 3 4 5)
     (roslisp-extended-reals:ext+ 7 3 'roslisp-extended-reals:infty 4 'roslisp-extended-reals:infty)
     (roslisp-extended-reals:ext+ 7 3 'roslisp-extended-reals:-infty 4 'roslisp-extended-reals:-infty)
     )
  (3 15 roslisp-extended-reals:infty roslisp-extended-reals:-infty))

(deftest ext+
    (list
     (roslisp-extended-reals:ext- 3)
     (roslisp-extended-reals:ext- -3)
     (roslisp-extended-reals:ext- 1 2 3 4 5)
     (roslisp-extended-reals:ext- 7 3 'roslisp-extended-reals:infty 4 'roslisp-extended-reals:infty)
     (roslisp-extended-reals:ext- 7 3 'roslisp-extended-reals:-infty 4 'roslisp-extended-reals:-infty)
     )
  (-3 3 -13 roslisp-extended-reals:-infty roslisp-extended-reals:infty))

(create-suite "extended-reals-test")