(in-package :test-roslisp)

(rem-all-tests)

(deftest test-tokens
    (values (roslisp-utils::tokens (format nil "a b~%c~&d~Te")))
  ("a" "b" "c" "d" "e"))

(deftest test-tokens-start
    (values (roslisp-utils::tokens (format nil "a b~%c~&d~Te") :start 5))
  ("d" "e"))

(deftest test-tokens-custom
  (values (roslisp-utils::tokens (format nil "a!b&c!d&e") :separators (list #\! #\&)))
  ("a" "b" "c" "d" "e"))

(deftest counter-value
    (let ((sym (gensym)))
      (list (roslisp-utils::counter-value sym)
            (roslisp-utils::counter-value sym)
            (roslisp-utils::counter-value sym)
            (roslisp-utils::counter-value sym)))
  (1 2 3 4))

(deftest every-nth
    (let ((i 0))
      (dotimes (x 20) (roslisp-utils::every-nth-time 4 (incf i)))
      i)
  5)

(create-suite "roslisp-utils-test")